---
# We need to patch DOCKER firewall for hosted containers to access caddy services (see: https://forums.docker.com/t/no-route-to-host-network-request-from-container-to-host-ip-port-published-from-other-container/39063/16)

- name: Verify traefik_opened_ports is defined
  assert:
    that: >
      traefik_opened_ports is defined
    msg: "traefik_opened_ports must be defined"

## Revoke all traefik rules
- name: "List existing traefik UFW rules - any/{{ item }}"
  become: yes
  shell: >
    ufw status numbered | grep -zoP '{% for port in traefik_opened_ports %}\[.*\]\s{{ port }}(?!\\d).*\n|{% endfor %}'  | sed -E 's/\[\s*([0-9]+)\].*$/\1/g'  | tr --delete [:blank:] | sed 's/\x0//g' | sort -rn | sed '/^s*$/d'
  changed_when: false
  register: ufw_traefik_rules

- name: UFW delete existing traefik rules - tcp,udp
  become: yes
  shell: "yes y | ufw delete {{ item|quote }}"
  with_items: "{{ ufw_traefik_rules.stdout_lines }}"

## End of revocation
- name: "Allow traefik ports (including containers) to pass firewall - any/{{ item }}"
  become: yes
  ufw:
    rule: allow
    proto: any
    port: "{{ item }}"
  with_items: "{{ traefik_opened_ports }}"
...